# Tcl/Tk UI for Polymaker plugin
# based on the original from G W Michel, updated by Inivis


proc makeit {} {
global shapefac polymake_dual

    set shapefac [selection get]
	ac3d polyhedronmakename $shapefac $polymake_dual
	ac3d redraw_all
}



proc makeChooser { parent } {
	# the left chooser

    set list "tetra cube penta hex octa dodeca icosa prism rhomb stell"
    ttk::frame $parent.clues
    pack $parent.clues -side left -fill both -expand 1

    ac_listbox $parent.clues.list -selectmode single -width 10
    foreach f $list {
        $parent.clues.list insert 0 $f
    }
    pack $parent.clues.list -fill both -expand 1
	$parent.clues.list selection set 0
    bind $parent.clues.list <Double-1> {
        set shapefac [selection get]
    }
}

proc makeChoice { parent } {
    set platolist "tetrahedron cube octahedron dodecahedron icosahedron"
    ac_frame $parent.poss
    pack $parent.poss -side right -fill both -expand 1
    ac_listbox $parent.poss.possibles -selectmode single -width 40

    $parent.poss.possibles configure -yscrollcommand "$parent.poss.scr set"

	bind $parent.poss.possibles <Double-ButtonPress-1> makeit

    pack $parent.poss.possibles -side left -fill both -expand 1 -padx 4
	set nch 0 
	# number of choices in the listbox
    foreach f $platolist {
        $parent.poss.possibles insert 0 $f
		incr nch
    }


	ac_scrollbar $parent.poss.scr -command "$parent.poss.possibles yview"
    pack $parent.poss.scr -side right -fill y
	return $nch
}

proc makeframe2 { parent } {
    ac_frame $parent.f2 
    pack $parent.f2 -side top -fill both -expand 1

# Choice list

	makeChooser $parent.f2

# and create the list of items that match the clue name
#possibles list

	return [makeChoice $parent.f2]

}



proc makeframe1 { parent } {
    ac_frame $parent.f1
    pack $parent.f1 -fill both -expand 0

    ac_checkbutton $parent.f1.d -text "Dual" -variable polymake_dual 
	add_balloon $parent.f1.d "generates the polygon's dual which is where the vertices of the dual shape correspond to the faces of the other"

	pack $parent.f1.d -side left
}




proc makechooser { parent} {
	global polymake_npos	

	set shapelist "none"

    ac_label $parent.title -text "algorithm by Dr. Zvi Har'El , interface by GWMichel"
    pack $parent.title -side top -fill x



# Choice and select poly frame; polymake_npos is number of elements in the choice widget 
	set polymake_npos [makeframe2 $parent ]


	makeframe1 $parent

# Go buttons, find, close

    ac_frame $parent.f3
    pack $parent.f3 -side bottom -fill x



    ttk::button $parent.f3.ok -text "Make" -command makeit
#{
#        set shapefac [selection get]
#		ac3d polyhedronmakename $shapefac $polymake_dual
#		ac3d redraw_all
#    }

    pack $parent.f3.ok -side left

	
	## AC - removed the button and bound the button release to get the list of possibles


	proc updatepossibles { parent } {
		global polymake_dual 
		global polymake_npos
	        set shapefac [selection get]
		  # get the shapes with this in the name
		ac3d polyhedronfind $polymake_dual $shapefac "shapelist"

		$parent.f2.poss.possibles delete 0 $polymake_npos
		set polymake_npos 0

		foreach f $shapelist {
		    $parent.f2.poss.possibles insert 0 $f
			incr polymake_npos
		}
	}

	bind $parent.f2.clues.list <ButtonRelease-1>  "updatepossibles $parent"
}



proc polymake_dialog {} {
  global id
  global polymake_dual
  global shapefac
  global shapelist
  global polymake_npos
  set polymake_dual 0
set id 0

	ac_toplevel_with_close .polymake "Polymaker" makechooser

}








