# AC3D
# Copyright (c) 2016, Inivis Limited. All rights reserved.


proc add_import_menu_item { label command } {
global UI

    $UI(menu_import) add command -label $label -command $command
}

proc add_export_menu_item { label command } {
global UI

    $UI(menu_export) add command -label $label -command $command
}

proc add_tools_menu_item { label command help } {
global balloon_menu_help UI

    $UI(menu_tools)  add command -label $label -command $command
    set balloon_menu_help($UI(menu_tools)) [concat $balloon_menu_help($UI(menu_tools)) "{ $help }"]
}

proc add_surface_menu_item { label command help} {
global balloon_menu_help UI

    $UI(menu_surface) add command -label $label -command $command
    set balloon_menu_help($UI(menu_surface)) [concat $balloon_menu_help($UI(menu_surface)) "{ $help }"]
}


proc add_vertex_menu_item { label command help} {
global balloon_menu_help UI

    $UI(menu_vertex) add command -label $label -command $command
    set balloon_menu_help($UI(menu_vertex)) [concat $balloon_menu_help($UI(menu_vertex)) "{ $help }"]
}


proc add_object_menu_item { label command help} {
global balloon_menu_help UI

    $UI(menu_object) add command -label $label -command $command
    set balloon_menu_help($UI(menu_object)) [concat $balloon_menu_help($UI(menu_object)) "{ $help }"]
}




proc get_ac3d_path { name } {
global prefs_plugin_dir
global AC3D_HOME

    if { $name == "plugins" } {
        return [eval "set temp $prefs_plugin_dir"]
    }
    return name
}




proc load_plugins { } {

set path [get_ac3d_path plugins]

    set oldd [pwd]
    set e [ catch { cd $path} ]

    if { $e } {
        puts "can't change to plugin dir '$path'"
    } else {
        set pwd [pwd]
        set plist ""
        catch { set plist [ glob *.p] }
#puts $plist
        foreach p $plist {
            ac3d plugin_load "$path/$p"
            }
    }
    cd $oldd
}








proc process_user_scripts { } {
# called at AC3D main startup - sources any *.tcl files

	#look in the 'scripts' directory within the AC3D installation.
	set path scripts

	if { ! [file exists scripts] } {
#		puts "no user script dir"
		return 1
	} else {
#		puts "user scripts dir found"
	}

    set oldd [pwd]
    set e [ catch { cd $path} ]

    if { $e } {
        puts "can't change to user script dir '$path'"
		return 0
    } else {
        set pwd [pwd]
        set plist ""
        catch { set plist [ glob *.tcl] }
		set plist [lsort $plist]

        foreach p $plist {
			puts "running user script $path/$p"
			
			if {[catch {uplevel #0 [list source $p]} msg]} {
				puts "$path/$p: $msg\n"
			}


#            set f [ catch { source "$p" } ]

            }
    }
    cd $oldd

	return 1
}































