# AC3D
# Copyright (c) 2016, Inivis Limited. All rights reserved.






proc do_render { } {
global prefs_render_command_new render_desc_list render_id_list UI prefs_render_command_param
global prefs_render_filename prefs_render_type prefs_render_command_new
global ac_platform

	if { [file exists $prefs_render_command_new] == 0 } {
		set result "The render program:\n$prefs_render_command_new\ndoes not exist or is not accessable.\nPlease set render program above."
		return $result
		}

	set result "Exporting $prefs_render_filename"

		set res [ac3d exporter_write_file $prefs_render_type $prefs_render_filename]

		if { $res != "OK" } {
			set result "$result\n$res"
			return $result;
		} else {
			set result "$result\nOK"
		}


		# if render command is not empty, look for %s and replace %s with the render_filename

		if { $prefs_render_command_param != "" } {
			regsub -all %s $prefs_render_command_param $prefs_render_filename ns
		} else {
			set ns ""
		}

		if { $ac_platform == "Windows" } {
			# to replace \ with \\ and backslash quotes
			regsub -all {[\]\[""\\$]} $prefs_render_command_new {\\&} command_slashed
			regsub -all {[\] [\ $]} $ns {\\&} param_slashed
			set commandline "exec  \"$command_slashed\" $param_slashed & "
		} elseif {$ac_platform == "Mac" } {
			# for old carbon programs? set carboncom "/System/Library/Frameworks/Carbon.framework/Versions/Current/Support/LaunchCFMApp"
			set carboncom open
			regsub -all " " $prefs_render_command_new "\\ " command_slashed
 			set commandline "$carboncom $command_slashed $ns"
       } else {
			set commandline "exec \"$prefs_render_command_new\" $ns & "
		}

puts "command line:\n$commandline"

		set result "$result\nExecuting: $commandline"

	if { $ac_platform == "Mac" } {
		ac3d execute "$commandline"
	} else {
		catch { set res [ eval $commandline ] }
	}
#ac3d execute $commandline

		if { $res == "" } { set res "Failed - check program path" }

		set result "$result\nResult: $res"
		return $result
}


proc combobox_changed { c value} {
global combo_value render_desc_list render_id_list prefs_render_type

	set i [lsearch $render_desc_list $combo_value]

	set id [lindex $render_id_list $i]
	set prefs_render_type $id
}



ac3d add_pref window_geom_render ""

proc create_render_ui { topf } {
global prefs_render_command render_desc_list render_id_list UI
global prefs_render_filename prefs_render_type prefs_render_command_new
global ac_platform

	set render $topf

	set ids [ac3d exporters_get_names]
	set descs [ac3d exporters_get_descs]

	set render_desc_list $descs
	set render_id_list $ids

	set width 60

#puts "ids $ids"

#source tcl/combobox.tcl
#package require combobox 2.2
catch {namespace import combobox::*}


#	combobox $render.exporterid -editable false -textvariable combo_value -command "combobox_changed"
	ttk::combobox $render.exporterid -textvariable combo_value

	
# -command "combobox_changed"

#	eval $render.exporterid  list insert end $descs
	$render.exporterid configure -values $descs
	$render.exporterid state readonly


	set current 1
	catch {set current [lsearch $ids $prefs_render_type]} { set current 1 }

	$render.exporterid current $current


    ac_label $render.ftlabel -text "Output file type:"
	add_balloon $render.ftlabel "Selects the type of file that AC3D will generate"

    ac_label $render.fnamelabel -text "Output filename:"
    ac_entry $render.filename -width $width -textvariable prefs_render_filename
	add_balloon $render.fnamelabel "The name of the file that is generated by AC3D and is then passed to the render command"
	ac_button $render.fnamebrowse -text "Browse..." -command {
		set res [tk_getSaveFile -title "Select output filename" -initialfile $prefs_render_filename -parent .render]
		if {$res != "" } {
			if { $ac_platform == "Windows" } {
				regsub -all "/" $res {\\} res 
			}

			set prefs_render_filename $res

		}
	}
	grid $render.fnamebrowse -row 2 -column 4 -sticky w


    grid $render.ftlabel -row 0 -column 0  -sticky e
    grid $render.exporterid -row 0 -column 1 -sticky w
	grid $render.fnamelabel -row 2 -column 0 -sticky e
	grid $render.filename -row 2 -column 1 -sticky w

	ac_label $render.commandlabel -text "Render program:"
	grid $render.commandlabel -row 3 -column 0 -sticky e
	add_balloon $render.commandlabel "The command that is executed when 'render' is pressed to start the external render.\nUse a '%s' in the this text to indicate where the filename is to be inserted."
    ac_entry $render.command -width $width -textvariable prefs_render_command_new
	grid $render.command -row 3 -column 1 -sticky we

	ac_button $render.commandbrowse -text "Browse..." -command {
#		set res [tk_getOpenFile -title "Select render program" -initialfile $prefs_render_command_new -parent .render]
		set res [tk_getOpenFile -title "Select render program"  -parent .render]
		if {$res != "" } {
			if { $ac_platform == "Windows" } {
				regsub -all "/" $res {\\} res 
			}
			set prefs_render_command_new $res
		}
	}

	grid $render.commandbrowse -row 3 -column 4 -sticky w



	ac_label $render.commandplabel -text "Render parameters:"
	grid $render.commandplabel -row 4 -column 0 -sticky e
	add_balloon $render.commandplabel "parameters - use a '%s' in the this text to indicate where the filename is to be inserted."
    ac_entry $render.commandp -width $width -textvariable prefs_render_command_param
	grid $render.commandp -row 4 -column 1 -sticky we


	ac_label $render.tlabel -text "Result:"
	grid $render.tlabel -row 7 -column 0  -sticky e
	set UI(renderoutput) [ ac_text $render.tf  -height 5 -width $width ]
	grid $render.tf -row 7 -column 1 -columnspan 2  -sticky we
	add_balloon $render.tlabel "Command line output and status report"


    ac_button $render.ok -text "Render" -command {
		set res [do_render]
		$UI(renderoutput) delete 0.0 end
		$UI(renderoutput) insert end $res
		}

	set srb [ac_checkbutton $render.srb -text "Show Render button on toolbar"  -command \
		 { \
			if { $prefs_show_render_button } { \
				pack $UI(renderbutton) -side left \
			} else { \
				pack forget $UI(renderbutton)  \
			 }
		 } -variable prefs_show_render_button ]

	grid $srb -row 8 -column 1 -stick w


    grid $render.ok -row 9 -column 0 -pady 3


}



proc menu_renderXXX { } {

	ac_toplevel_with_close .render "Render" create_render_ui
}


################################

ac3d add_pref dialog_export_selected_what selection
ac3d add_pref dialog_export_selected_filetype 3DS
ac3d add_pref dialog_export_selected_filename "filename.ext"


proc create_export_selected_ui { topf } {
global prefs_dialog_export_selected_what prefs_dialog_export_selected_filetype  prefs_dialog_export_selected_filename
global exp_sel_ids

	set render $topf
	set exp_sel_ids [ac3d exporters_get_names]
	set descs [ac3d exporters_get_descs]
	set width 32
	set render_desc_list $descs


	set variable prefs_dialog_export_selected_what
	ac_create_radiobutton_strip $render.exportwhat $variable { "Selection only" "All" } { selection all }  "" 
	grid $render.exportwhat -row 0 -column 1 -sticky w


	ttk::combobox $render.exporterid -textvariable export_selected_desc 
	bind $render.exporterid <<ComboboxSelected>> {
		set c [%W current]
		set d [lindex $exp_sel_ids $c]
		set prefs_dialog_export_selected_filetype $d
	}

	$render.exporterid configure -values $descs
	$render.exporterid state readonly


    ac_label $render.ftlabel -text "Output file type:"
	add_balloon $render.ftlabel "Selects the type of file that AC3D will generate"

    grid $render.ftlabel -row 1 -column 0  -sticky e
    grid $render.exporterid -row 1 -column 1 -sticky w

	set current 0
	catch {set current [lsearch $exp_sel_ids $prefs_dialog_export_selected_filetype ]} 

	$render.exporterid current $current


	ac_create_pair_label_savefilename $render prefs_dialog_export_selected_filename "Filename" "Output file name/path for exported file\nNote: filenames can have any extension and WILL OVERWRITE an existing file of the same name" 40



set but [ ac_create_pair_button $render "Export" { 
	puts "current desc: $export_selected_desc"
	set cd $export_selected_desc
	set descs [ac3d exporters_get_descs]
	set names [ac3d exporters_get_names]

	set ci [lsearch $descs $cd]
	puts "current id $ci"
	set n [lindex $names $ci]
	puts "chosen exporter name $n"
	if { $prefs_dialog_export_selected_what == "all"} {
		ac3d exporter_write_file $n $prefs_dialog_export_selected_filename 
	} else {
		ac3d export_selection $prefs_dialog_export_selected_filetype $prefs_dialog_export_selected_filename 
	}
	
}]


}

proc menu_render {} {
ac_toplevel_with_close .render "Render" create_render_ui "" 1
}

proc menu_export_selected {} {
ac_toplevel_with_close .exportselected "Export" create_export_selected_ui "" 1

}

